﻿using System;
using System.ServiceModel;

namespace TestServer
{
    /// <summary>
    /// 계산기 서비스
    /// </summary>
    public class CalculatorService : ICalculatorService
    {
        ////////////////////////////////////////////////////////////////////////////////////////// Method
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 나누기 - Divide(numerator, denominator)

        /// <summary>
        /// 나누기
        /// </summary>
        /// <param name="numerator">분모</param>
        /// <param name="denominator">분자</param>
        /// <returns>몫</returns>
        public int Divide(int numerator, int denominator)
        {
            try
            {
                return numerator / denominator;
            }
            catch(DivideByZeroException exception)
            {
                DivideByZeroFault divideByZeroFault = new DivideByZeroFault();

                divideByZeroFault.Error  = exception.Message;
                divideByZeroFault.Detail = "분모는 0이 될 수 없습니다.";

                throw new FaultException<DivideByZeroFault>(divideByZeroFault);
            }
        }

        #endregion
    }
}